commit 4f556312da96bf2db67b014612de86594d4ad003
Author: Martin Sebor <msebor@redhat.com>
Date:   Thu Dec 16 23:35:55 2021

    Check for class type before assuming a type is one [PR103703].
    
    Resolves:
    PR c++/103703 - ICE with -Wmismatched-tags with friends and templates
    
    gcc/cp/ChangeLog:
    
            PR c++/103703
            * parser.c (class_decl_loc_t::diag_mismatched_tags): Check for class
            type before assuming a type is one.
    
    gcc/testsuite/ChangeLog:
    
            PR c++/103703
            * g++.dg/warn/Wmismatched-tags-9.C: New test.

diff --git a/gcc/cp/parser.c b/gcc/cp/parser.c
index af10caa48be..01006989a02 100644
--- a/gcc/cp/parser.c
+++ b/gcc/cp/parser.c
@@ -32437,7 +32437,7 @@ class_decl_loc_t::diag_mismatched_tags (tree type_decl)
   class_decl_loc_t *cdlguide = this;
 
   tree type = TREE_TYPE (type_decl);
-  if (CLASSTYPE_IMPLICIT_INSTANTIATION (type))
+  if (CLASS_TYPE_P (type) && CLASSTYPE_IMPLICIT_INSTANTIATION (type))
     {
       /* For implicit instantiations of a primary template look up
 	 the primary or partial specialization and use it as
diff --git a/gcc/testsuite/g++.dg/warn/Wmismatched-tags-9.C b/gcc/testsuite/g++.dg/warn/Wmismatched-tags-9.C
new file mode 100644
index 00000000000..2712c4de1f6
--- /dev/null
+++ b/gcc/testsuite/g++.dg/warn/Wmismatched-tags-9.C
@@ -0,0 +1,32 @@
+/* PR c++/103703 - ICE with -Wmismatched-tags with friends and templates
+   { dg-do compile }
+   { dg-options "-Wall -Wmismatched-tags" } */
+
+template <typename T>
+struct A
+{
+  struct B { };
+};
+
+template <typename T>
+struct C
+{
+  friend class A<C>::B;       // { dg-warning "-Wmismatched-tags" "pr102036" { xfail *-*-* } }
+};
+
+template struct C<int>;
+
+
+template <typename T>
+struct D
+{
+  friend class A<D>::B;       // okay, specialized as class below
+};
+
+template <>
+struct A<long>
+{
+  class B { };
+};
+
+template struct D<long>;

